package jdk.management.resource.internal.inst;

import jdk.internal.instrumentation.InstrumentationMethod;
import java.io.IOException;
import jdk.management.resource.internal.ApproverGroup;
import jdk.management.resource.internal.ResourceIdImpl;
import java.net.InetSocketAddress;
import java.io.FileDescriptor;
import jdk.internal.instrumentation.InstrumentationTarget;

@InstrumentationTarget("sun.nio.ch.WindowsAsynchronousServerSocketChannelImpl")
public class WindowsAsynchronousServerSocketChannelImplRMHooks
{
    protected final FileDescriptor fd;
    protected volatile InetSocketAddress localAddress;
    
    public WindowsAsynchronousServerSocketChannelImplRMHooks() {
        this.fd = null;
        this.localAddress = null;
    }
    
    @InstrumentationMethod
    void implClose() throws IOException {
        try {
            this.implClose();
            ResourceIdImpl of = ResourceIdImpl.of(this.fd);
            if (of != null) {
                ApproverGroup.FILEDESCRIPTOR_OPEN_GROUP.getApprover(this.fd).request(-1L, of);
            }
            if (this.localAddress != null) {
                ApproverGroup.SOCKET_OPEN_GROUP.getApprover(this).request(-1L, ResourceIdImpl.of(this.localAddress));
            }
        }
        finally {
            ResourceIdImpl of2 = ResourceIdImpl.of(this.fd);
            if (of2 != null) {
                ApproverGroup.FILEDESCRIPTOR_OPEN_GROUP.getApprover(this.fd).request(-1L, of2);
            }
            if (this.localAddress != null) {
                ApproverGroup.SOCKET_OPEN_GROUP.getApprover(this).request(-1L, ResourceIdImpl.of(this.localAddress));
            }
        }
    }
}
